function [rmi,rm,rd,gmi,gm,gd,bmi,bm,bd]=estadisticRGB(im)
%funcio que donada una imatge, ens retorna la mitjana, la mediana i 
%la desviaci de cada una de les seves components (rgb)

%Guardem cada component de RGB en una matriu per separat 
R=im(:,:,1);
G=im(:,:,2);
B=im(:,:,3);

%calculem mitjana,mediana, i desviaci de cada component

%stadistics L
rmi=mean2(R);

%paso a un vector la matriu per a poder utilitzar la mediana i std
rvec=matrix2vector(R);
rm=median(rvec);
rd=std(rvec);

%stadistics A
gmi=mean2(G);

%paso a un vector la matriu per a poder utilitzar la mediana i std
gvec=matrix2vector(G);
gm=median(gvec);
gd=std(gvec);

%stadistics B
bmi=mean2(B);

%paso a un vector la matriu per a poder utilitzar la mediana i std
bvec=matrix2vector(B);
bm=median(bvec);
bd=std(bvec);
end