function [QC11,QC21,QC31,QC12,QC22,QC32,QC13,QC23,QC33]=Principal(im1,im2,threshold)
%Funci que donada una imatge, una imatge patr (im1) i una imatges mostra
%(im2), retorna la quantitat de vermell, verd i blau que t la imatges
%mostra respecte la patr per a cada uno de les 3 capes (QR,QG,QB)

%------------1 PAS
%Alineaci Imatges


aliniacio=['rmRegMIAT',' "',im1,'" "',im2,'" ','1',' ','a',' ','2',' ','0'];
dos(aliniacio);

%------------2 PAS
% Treure marges negres, produits per la alineaci
 
%Treure '.bmp' al nom de la imatge
numLletres1=size(im1,2);
numLletres2=size(im2,2);
im1=im1(1:numLletres1-4);
im2=im2(1:numLletres2-4);
%Afegir al nom de la imatge la extensi _t.bmp que es la que retorna el
%programa de alineacio
im1_a=[im1,'_t','.bmp'];
im2_a=[im2,'_t','.bmp'];
%passar a RGB les imatges alineades
im1_a=imread(im1_a); 
im2_a=imread(im2_a); 
[im1_f,im2_f]=eliminaCostatsNegres(im1_a,im2_a);

subplot(2,2,1);imshow(im1_a);title('Imatges alineades');

subplot(2,2,2);imshow(im2_a);

subplot(2,2,3);imshow(im1_f);;title('Imatges sense marges negres');

subplot(2,2,4);imshow(im2_f);

%------------3 PAS
%Creaci de 9 vectors( 3 vectors RGB per 3 capes) i d'una matru de
%posicins que estar composta per 0 i 1, els 1 seran pixels amb informaci

%Trobar el num de files i columnes de cada component RGB de la imatge
[numFil,numCol] = size(im1_f(:,:,1));

MatPosCapa1=zeros(numFil,numCol);
MatPosCapa2=zeros(numFil,numCol);
MatPosCapa3=zeros(numFil,numCol);

VecRcapa1=[];
VecGcapa1=[];
VecBcapa1=[];
VecRcapa2=[];
VecGcapa2=[];
VecBcapa2=[];
VecRcapa3=[];
VecGcapa3=[];
VecBcapa3=[];

Ttlpixelscapa1=0;
Ttlpixelscapa2=0;
Ttlpixelscapa3=0;


for files=1:numFil
    for columnes=1:numCol
        r=im1_f(files,columnes,1);%Valor de la component r pixel fil,col
        g=im1_f(files,columnes,2);%Valor de la component g pixel fil,col
        b=im1_f(files,columnes,3);%Valor de la component b pixel fil,col
        
        %Standaritzar components r g b del pixel
        [R,G,B]=Standrgb2RGB(r,g,b);
        
        %Creaci de les matrius a analitzar
        %Matriu A s la informaci RGB de cada una de les capes per separat
        %Matriu B s la informaci RGB del pixel
        Acapes=[0.3876 0.4409 0.3587;0.3411 0.3011 0.3333;0.2713 0.2581 0.3079];
        Bpixel=[R;G;B];
        
        %Aplicaci formula lsqlin per resoltre 3 incognites de les
        %matrius,retorna una matriu (x y z)
        resultat=lsqlin(Acapes,Bpixel,[],[],[],[],[],[]);
       
        %Pertany capa1??
        if (((resultat(1,1)>=(1-threshold))&(resultat(1,1)<=(1+threshold)))& ((resultat(2,1)>=(0-threshold))&(resultat(2,1)<=(0+threshold))) & ((resultat(3,1)>=(0-threshold))&(resultat(3,1)<=(0+threshold))))            
        Ttlpixelscapa1=Ttlpixelscapa1+1;
        
        %Guardar posici a matriu de posicions i cada component r g b al
        %seu vector corresponent per a posterior tractament
        MatPosCapa1(files,columnes)=1;
        VecRcapa1(Ttlpixelscapa1)=r;
        VecGcapa1(Ttlpixelscapa1)=g;
        VecBcapa1(Ttlpixelscapa1)=b;
        end
        
        %Pertany capa2??
        if (((resultat(2,1)>=(1-threshold))&(resultat(2,1)<=(1+threshold)))& ((resultat(1,1)>=(0-threshold))&(resultat(1,1)<=(0+threshold))) & ((resultat(3,1)>=(0-threshold))&(resultat(3,1)<=(0+threshold))))
        Ttlpixelscapa2=Ttlpixelscapa2+1;  
        
        %Guardar posici a matriu de posicions i cada component r g b al
        %seu vector corresponent per a posterior tractament
        MatPosCapa2(files,columnes)=1;
        VecRcapa2(Ttlpixelscapa2)=r;
        VecGcapa2(Ttlpixelscapa2)=g;
        VecBcapa2(Ttlpixelscapa2)=b;
        end
        
        %Pertany capa3??
        if (((resultat(3,1)>=(1-threshold))&(resultat(3,1)<=(1+threshold)))& ((resultat(1,1)>=(0-threshold))&(resultat(1,1)<=(0+threshold))) & ((resultat(2,1)>=(0-threshold))&(resultat(2,1)<=(0+threshold))))
        Ttlpixelscapa3=Ttlpixelscapa3+1; 
        
        %Guardar posici a matriu de posicions i cada component r g b al
        %seu vector corresponent per a posterior tractament
        MatPosCapa3(files,columnes)=1;
        VecRcapa3(Ttlpixelscapa3)=r;
        VecGcapa3(Ttlpixelscapa3)=g;
        VecBcapa3(Ttlpixelscapa3)=b;
        end
        columnes=columnes+1;
    end
    files=files+1;
end
%Mostrar les matrius posicions i el n de pixels que t cada capa en la
%imatge Patr
figure;
subplot(2,2,1);imshow(MatPosCapa1);title('Pixels pertanyents capa1');xlabel(Ttlpixelscapa1);
subplot(2,2,2);imshow(MatPosCapa2);title('Pixels pertanyents capa2');xlabel(Ttlpixelscapa2);
subplot(2,2,3);imshow(MatPosCapa3);title('Pixels pertanyents capa3');xlabel(Ttlpixelscapa3);

%------------4 PAS
%Creaci de 9 vectors( 3 vectors RGB per 3 capes) que contenen la
%informaci RGB de cada una de les capes de la imatge mostra 

VecRcapa1_M=[];
VecGcapa1_M=[];
VecBcapa1_M=[];
VecRcapa2_M=[];
VecGcapa2_M=[];
VecBcapa2_M=[];
VecRcapa3_M=[];
VecGcapa3_M=[];
VecBcapa3_M=[];

Ttlpixelscapa1_M=1;
Ttlpixelscapa2_M=1;
Ttlpixelscapa3_M=1;

for files=1:numFil
    for columnes=1:numCol
        if MatPosCapa1(files,columnes)==1
           %S'intenta evitar guardar pixels amb soroll (+-0)
           if(im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5)
           VecRcapa1_M(Ttlpixelscapa1_M)=im2_f(files,columnes,1);
           VecGcapa1_M(Ttlpixelscapa1_M)=im2_f(files,columnes,2);
           VecBcapa1_M(Ttlpixelscapa1_M)=im2_f(files,columnes,3);
           Ttlpixelscapa1_M=Ttlpixelscapa1_M+1;
           end
        end
        
        if MatPosCapa2(files,columnes)==1
           if(im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5) 
           VecRcapa2_M(Ttlpixelscapa2_M)=im2_f(files,columnes,1);
           VecGcapa2_M(Ttlpixelscapa2_M)=im2_f(files,columnes,2);
           VecBcapa2_M(Ttlpixelscapa2_M)=im2_f(files,columnes,3);
           Ttlpixelscapa2_M=Ttlpixelscapa2_M+1;
           end
        end
        
        if MatPosCapa3(files,columnes)==1
           if(im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5 & im2_f(files,columnes,1)>=5)
           VecRcapa3_M(Ttlpixelscapa3_M)=im2_f(files,columnes,1);
           VecGcapa3_M(Ttlpixelscapa3_M)=im2_f(files,columnes,2);
           VecBcapa3_M(Ttlpixelscapa3_M)=im2_f(files,columnes,3);
           Ttlpixelscapa3_M=Ttlpixelscapa3_M+1;
           end
        end
        columnes=columnes+1;
    end
    files=files+1;
end    

%------------5 PAS
%Extreure medianes o mitjanes vectors RGB de cada capa de la imatge patr i
%mostra i aplicar-hi el metode quantitats (valors dels colors preestablerts
%e identics per a la mostra i patr.

%Poc sensible a valors atpics (soroll), ideal per a mostra amb distribucions
%asimetriques
%[MitjanaRcapa1,MitjanaGcapa1,MitjanaBcapa1]=mitjanesRGB(VecRcapa1,VecGcapa1,VecBcapa1);
%[MitjanaRcapa2,MitjanaGcapa2,MitjanaBcapa2]=mitjanesRGB(VecRcapa2,VecGcapa2,VecBcapa2);
%[MitjanaRcapa3,MitjanaGcapa3,MitjanaBcapa3]=mitjanesRGB(VecRcapa3,VecGcapa3,VecBcapa3);

%[MitjanaRcapa1_M,MitjanaGcapa1_M,MitjanaBcapa1_M]=mitjanesRGB(VecRcapa1_M,VecGcapa1_M,VecBcapa1_M);
%[MitjanaRcapa2_M,MitjanaGcapa2_M,MitjanaBcapa2_M]=mitjanesRGB(VecRcapa2_M,VecGcapa2_M,VecBcapa2_M);
%[MitjanaRcapa3_M,MitjanaGcapa3_M,MitjanaBcapa3_M]=mitjanesRGB(VecRcapa3_M,VecGcapa3_M,VecBcapa3_M);

%Ms sensible a valors atpics, ideal per a mostra amb distribucions
%simetriques
[MedianaRcapa1,MedianaGcapa1,MedianaBcapa1]=medianesRGB(VecRcapa1,VecGcapa1,VecBcapa1);
[MedianaRcapa2,MedianaGcapa2,MedianaBcapa2]=medianesRGB(VecRcapa2,VecGcapa2,VecBcapa2);
[MedianaRcapa3,MedianaGcapa3,MedianaBcapa3]=medianesRGB(VecRcapa3,VecGcapa3,VecBcapa3);

[MedianaRcapa1_M,MedianaGcapa1_M,MedianaBcapa1_M]=medianesRGB(VecRcapa1_M,VecGcapa1_M,VecBcapa1_M);
[MedianaRcapa2_M,MedianaGcapa2_M,MedianaBcapa2_M]=medianesRGB(VecRcapa2_M,VecGcapa2_M,VecBcapa2_M);
[MedianaRcapa3_M,MedianaGcapa3_M,MedianaBcapa3_M]=medianesRGB(VecRcapa3_M,VecGcapa3_M,VecBcapa3_M);

%Creaci de les matrius per a fer analisi de les quantitats en percentatges

if isnan(MedianaRcapa1)==1
    disp('Imatge sense pixels de capa 1');
    QC11=0;
    QC21=0;
    QC31=0;
else
Acolors=[0.43 0.48 0.35;0.38 0.3 0.33 ;0.19 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa1,MedianaGcapa1,MedianaBcapa1);
Bcapa=[R;G;B];
resultatCapa1=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);        

Acolors=[0.43 0.48 0.35;0.38 0.3 0.33 ;0.19 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa1_M,MedianaGcapa1_M,MedianaBcapa1_M);
Bcapa=[R;G;B];
resultatCapa1_M=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);

QC11=(resultatCapa1_M(1,1)-resultatCapa1(1,1));
QC21=(resultatCapa1_M(2,1)-resultatCapa1(2,1));
QC31=(resultatCapa1_M(3,1)-resultatCapa1(3,1));

end

if isnan(MedianaRcapa2)==1
    disp('Imatge sense pixels de capa 2');
    QC12=0;
    QC22=0;
    QC32=0;
else
Acolors=[0.58 0.48 0.35;0.18 0.3 0.33 ;0.24 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa2,MedianaGcapa2,MedianaBcapa2);
Bcapa=[R;G;B];
resultatCapa2=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);

Acolors=[0.58 0.48 0.35;0.18 0.3 0.33 ;0.24 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa2_M,MedianaGcapa2_M,MedianaBcapa2_M);
Bcapa=[R;G;B];
resultatCapa2_M=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);       

QC12=(resultatCapa2_M(1,1)-resultatCapa2(1,1));
QC22=(resultatCapa2_M(2,1)-resultatCapa2(2,1));
QC32=(resultatCapa2_M(3,1)-resultatCapa2(3,1));

end

if isnan(MedianaRcapa3)==1
    disp('Imatge sense pixels de capa 3');
    QC13=0;
    QC23=0;
    QC33=0;
else
Acolors=[0.58 0.48 0.35;0.18 0.3 0.33 ;0.24 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa3,MedianaGcapa3,MedianaBcapa3);
Bcapa=[R;G;B];
resultatCapa3=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);

Acolors=[0.58 0.48 0.35;0.18 0.3 0.33 ;0.24 0.22 0.32];
[R,G,B]=Standrgb2RGB(MedianaRcapa3_M,MedianaGcapa3_M,MedianaBcapa3_M);
Bcapa=[R;G;B];
resultatCapa3_M=lsqlin(Acolors,Bcapa,[],[],[],[],0,[]);

QC13=(resultatCapa3_M(1,1)-resultatCapa3(1,1));
QC23=(resultatCapa3_M(2,1)-resultatCapa3(2,1));
QC33=(resultatCapa3_M(3,1)-resultatCapa3(3,1));

end

%fi de programa
end

